


# Draws dovetail tails on board to demo problem with push pull in API
 
require 'sketchup.rb'



module K2WS
 
class K2_DovetailTails  
   
    
	def initialize
		@mod = Sketchup.active_model
		@sel = @mod.selection
		@ip = Sketchup::InputPoint.new
		@inpt = Sketchup::InputPoint.new		
		@tinpt= Sketchup::InputPoint.new
		@ang = 7.to_f
		@rise = Math.tan(@ang.degrees)
    self.reset
  end    
	
	def reset
		@best = nil; @comp1 = nil; @comp2 = nil; @sel.clear; @status = 0; @drawn = false
	end

	def cal_xCL_points(x1,e_len)
		@quanity = 5
		@xcl=Array.new @quanity
		@hpt = 0.25.to_l; @fpt = 0.50.to_l
		equal_offset=(e_len-(@hpt-(@fpt/2)))/(@quanity-1)
				@xcl[0]=x1+(@hpt-(@fpt/2))
				@xcl[@quanity-1]=x1+(e_len-(@hpt-(@fpt/2)))
				n =(@quanity-2)	#loop number
				sn = 1 #Starting number
				while n > 0
					@xcl[sn]=@xcl[sn-1]+(equal_offset)
					sn = sn + 1
					n = n -1
				end # while n > 0
				#Debug @xcl.each {|e| UI.messagebox("Auto CL point = "+ e.to_s)}	
	end #cal_xCL_points
	  
	def onMouseMove(flags, x, y, view)
		Sketchup::set_status_text("Select Component:   SPACE BAR to Exit", SB_PROMPT) if @status==0
		Sketchup::set_status_text("Select THICKNESS EDGE:   [SPACE BAR] to Exit",SB_PROMPT) if @status==1
		Sketchup::set_status_text("Select Width EDGE in component to Define EDGE 1:   [SPACE BAR] to Exit",SB_PROMPT)  if @status==2
		Sketchup::set_status_text("Select Length EDGE in component 90 degrees to Edge 1:   [SPACE BAR] to Exit",SB_PROMPT) if @status==3
		Sketchup::set_status_text("Program Continues:   SPACE BAR to Exit", SB_PROMPT) if @status==4
		@ip.pick view,x,y
		view.tooltip = @ip.tooltip     
		view.refresh
	end
	
	def onLButtonDown(flags, x, y, view)
		if @status==0 #select 1st component
			ph=view.pick_helper; ph.do_pick x,y; @comp1=ph.best_picked
			if @comp1 && (@comp1.is_a?(Sketchup::ComponentInstance))
				@sel.add(@comp1); @ent1=@comp1.definition.entities; @status=1
				onMouseMove(flags, x, y, view)
        @status = 1
			else
				UI.messagebox "Selection invalid, must be component"
			end #@comp1
		elsif @status==1 #select thickness edge  @edge3
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge3 = @ip.edge; @edge3L = @edge3.length
					@status = 2
					onMouseMove(flags, x, y, view)
				else
					UI.messagebox "Selection invalid "
				end #if(@ip.edge
			else
				UI.messagebox "Selection invalid "	
			end #if(@ip.valid?)			
		elsif @status==2 #select long edge, width
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge1 = @ip.edge; @e_len1=@edge1.length
					@status = 3
					onMouseMove(flags, x, y, view)
				else
					UI.messagebox"Other Component is Interfering with pick: Use Right Button Click and Hide before Continuing!"
					self.reset
				end
			end
		elsif @status==3 #select long edge, length 
			@ip.pick view,x,y
			if(@ip.valid?)
				if(@ip.edge && @ent1.include?(@ip.edge))
					@edge2 = @ip.edge; @edge2_length=@edge2.length          
          @status = 4
					onMouseMove(flags, x, y, view)
					# Draw Tails
					@mod.start_operation "Dovtail Joint"
					wid = @edge1.length					
					#Calculate Change in x due to @rise across thickness of Pin Board
					del_x = @rise * @edge3L
					xcl = 1.0.to_l	#for testing dimension from outside edge to cl of next pin
					#Calculate Starting Points
					p0 = Geom.intersect_line_line(@edge1.line,@edge2.line)
					p1,x1=@edge1.line; x1.reverse! if p0 != p1
					p1,ya=@edge2.line; ya.reverse! if p0 != p1
					#Debug  UI.messagebox("ya = "+ ya.to_s)
					#Debug  UI.messagebox("hgt = "+ hgt.to_s)
					pa=p0.offset(ya,@edge3L)
					#Get CL points for the pin features
					p0x = 0.0 #p0.x <--------------- changed this from p0.x to 0.0
					cal_xCL_points(p0x,wid)					
					pp1=pa; pp2=p0
					for i in 0...@quanity-1
						pp3=p0.offset(x1,@xcl[i]+@fpt/2)
						pp4=pa.offset(x1,@xcl[i]+@fpt/2+del_x)
						pp2p = [pp2.x,pp2.y,p0.z]
						pp3p = [pp3.x,pp3.y,p0.z]
						pp4p = [pp4.x,pp4.y,p0.z]
						#Debug UI.messagebox("pp1p = " + pp1p.to_s)
						# Add Detail to Component 1
						@comp1.hidden=false
						@entity=@comp1
						codef=@entity.definition
						cface=codef.entities.add_face(pp1,pp2,pp3,pp4)
			#cface.pushpull -@edge3L
						pp1=pa.offset(x1,@xcl[i+1]-@fpt/2-del_x)
						pp2=p0.offset(x1,@xcl[i+1]-@fpt/2) #pp1 (Pin Point 1) starts at half pin thickness from first @xcl
					end
					pp3=p0.offset(x1,wid); pp4=pa.offset(x1,wid)
					pp2p = [pp2.x,pp2.y,p0.z]
					pp3p = [pp3.x,pp3.y,p0.z]
					pp4p = [pp4.x,pp4.y,p0.z]
					cface=codef.entities.add_face(pp1,pp2,pp3,pp4)
			#cface.pushpull -@edge3L
					@mod.commit_operation
					self.reset
					Sketchup.send_action "selectSelectionTool:"
				else
					UI.beep
				end # if(@ip.valid?)
			end
		end # if @status
	end#def onLButtonDown

end #end class K2_DovetailTails


# Run Once
		unless file_loaded?(File.basename(__FILE__))
		
    #Add Commands to Tool Menu
    tools_menu = UI.menu "Tools"
    # Add a separator and a submenu
    tools_menu.add_separator
    #sub_menu = tools_menu.add_submenu("K2WS_")
		it2= tools_menu.add_item("K2TestPP"){Sketchup.active_model.select_tool K2WS::K2_DovetailTails.new}
    end #unless file_loaded?
end #module

 
 
